import IKDBBaseQuery from './IKDBBaseQuery';
import Utils from './../API/IKUtils';
//
import AWS from "aws-sdk";
//
export default class IKDBQueryGet extends IKDBBaseQuery {
  constructor(optIndexName) {
    super(optIndexName);
  }
  async run(dbManager) {
    const resp = await this.rawRun(dbManager);
    if (resp.Items) {
      const unmarshalled = Utils.decapsulateForDB(resp.Items);
      console.debug('Parsed result: ', unmarshalled);
      return unmarshalled;
    } return null;
  }
  async rawRun(dbManager) {
    const query = this._rawQuery(dbManager.tableName);
    console.log('Querying: ', query);
    const resp = await dbManager.connection.query(query).promise();
    console.debug('Raw result: ', resp);
    return resp;
  }
}


/*marshalling should be done
let unMarshalled = dbResp.Items.map((item) => {
  let i = AWS.DynamoDB.Converter.unmarshall(item);
  const  { gsi1sk, gsi3pk,...otherProps } = i;
  const activitydate = gsi1sk;
  const ctid = gsi3pk;
  const ret = { activitydate, ctid, ...otherProps };
  console.log("um:", ret);
  return ret;
});
unMarshalled.request_data = AWS.DynamoDB.Converter.unmarshall(unMarshalled.request_data);
console.log(unMarshalled);
return unMarshalled;
*/
